; *****************************************************************************
; *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
; *                                                                            
; * ocl.el - very simplistic OCL-mode for Emacs
; * Copyright (C) 2005 Achim D. Brucker <brucker@inf.ethz.ch>   
; *                                                                            
; * This file is part of HOL-OCL.                                              
; *                                                                            
; * HOL-OCL is free software; you can redistribute it and/or modify it under   
; * the terms of the GNU General Public License as published by the Free       
; * Software Foundation; either version 2 of the License, or (at your option)  
; * any later version.                                                         
; *                                                                            
; * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
; * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
; * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
; * details.                                                              
; *                                                                            
; * You should have received a copy of the GNU General Public License along    
; * with this program; if not, write to the Free Software Foundation, Inc.,    
; * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
; ******************************************************************************

(require 'generic)

(define-generic-mode 'ocl
  '("--" ("/*" . "*/"))
  ;; outermost OCL keywords
  (list  
   "package"
   "endpackage"
   "context"
   "inv"
   "pre"
   "post"
   "derive"
   "def"
   "init"
   "body"
   )
  (list
   ;; logical infix operators
   (list "\\W\\(and\\|or\\|xor\\|implies\\|if\\|then\\|else\\|endif\\|let\\|in\\)\\W" 
	 '(1 font-lock-type-face))
   (list "\\(@pre\\)\\W" 
	 '(1 font-lock-type-face))
   ;; operations
   (list "\\(\\w+(\.*)\\s-*:\\s-*\\(\\w\\|(\\|)\\)+\\)" 
	 '(1 font-lock-function-name-face))
   ;; names of OCL formulae
   (list "\\(\\<inv\\|pre\\|post\\|derive\\|def\\) \\W*\\(\\(\\w\\|_\\)+\\) *:" 
	 '(2 font-lock-variable-name-face))
   ;; string constants
   (list "'[^']+'" 
	 '(0 font-lock-string-face))
   )
  (list "\\.ocl\\'")
  nil
  "Generic mode for OCL specification files.")
(provide 'ocl)
