// $Id: CurrencyTradingAccountTest.java,v 1.1 2000/09/21 13:28:58 brucker Exp $
package unifreiburg.informatik.softech.ebank.test;
import unifreiburg.informatik.softech.ebank.*;
import java.util.*;

public class CurrencyTradingAccountTest extends TestSuite {
    public String getTestSuiteName() {
        return "Test of CurrencyTradingAccount object";
    }

    public boolean testInit() {
        super.printTestCaseName("Testing constructor CurrencyTradingAccount(int)");
	CurrencyTradingAccount  account = new CurrencyTradingAccount(1);
       	return true;
    }    
    public boolean testGetter() {
	boolean retval=true;
	super.printTestCaseName("Testing getter methods of class CurrencyTradingAccount");
	CurrencyTradingAccount account = new CurrencyTradingAccount(3,"USD",100.0,"JPY",0.01);
	if(account.getBalance()!=10000.0) {
	    retval = false;
	}
	if(account.getCurrency()!="USD") {
	    retval = false;
	}
	if(account.getNormBalance()!=100){
	    retval = false;
	}
	if(account.getTradingCurrency() != "JPY"){
	    retval = false;
	}
	return retval;
    }
    public boolean testMakeWithdrawal() {
	boolean retval=true;
	boolean state=false;
	super.printTestCaseName("Testing makeWithdrawal()");
	CurrencyTradingAccount account = new CurrencyTradingAccount(3,"USD",100.0,"JPY",0.01);
	state=account.makeWithdrawal(49.20);
	if((state)&&(account.getBalance()!=50.80)){
	    retval=false;
	}
	
	if(account.makeWithdrawal(-100.00)){
	    //    retval=false;
	}
	return retval;
    }
    public boolean testMakeDeposit() {
	boolean retval=true;
	boolean state=false;
	super.printTestCaseName("Testing makeDeposit()");
	CurrencyTradingAccount account = new CurrencyTradingAccount(3,"USD",100.0,"JPY",0.01);
	state=account.makeDeposit(49.20);
	if((state)&&(account.getBalance()!=149.20)){
	    retval=false;
	}
	if(account.makeWithdrawal(-100.00)){
	    //   retval=false;
	}
	return retval;
    }
    public boolean testBuy() {
	boolean retval=true;
	boolean state=false;
	super.printTestCaseName("Testing buy()");
	CurrencyTradingAccount account = new CurrencyTradingAccount(3,"USD",100.0,"JPY",0.01);
	state=account.buy(49.20);
	if((state)&&(account.getBalance()!=149.20)){
	    retval=false;
	}
	if(account.buy(-100.00)){
	    //   retval=false;
	}
	return retval;
    }        
    public boolean testSell() {
	boolean retval=true;
	boolean state=false;
	super.printTestCaseName("Testing sell()");
	CurrencyTradingAccount account = new CurrencyTradingAccount(3,"USD",100.0,"JPY",0.01);
	state=account.sell(49.20);
	if((state)&&(account.getBalance()!= 50.80)){
	    retval=false;
	}
	if(account.buy(-100.00)){
	    //   retval=false;
	}
	return retval;
    }        
}
