// $Id: eBankTestClient.java,v 1.5 2000/09/21 13:22:37 brucker Exp $
package unifreiburg.informatik.softech.ebank.test;
import java.util.*;
import java.lang.reflect.*;
import unifreiburg.informatik.softech.ebank.*;
import tudresden.ocl.injection.lib.Invariant;

public class eBankTestClient
{
    static public void main(String[] args)
    {
	// configuration of the dresden OCL lib
	tudresden.ocl.lib.Ocl.TOLERATE_NONEXISTENT_FIELDS=true;
	tudresden.ocl.lib.Ocl.setNameAdapter(new tudresden.ocl.lib.ArgoNameAdapter());
	tudresden.ocl.injection.lib.Invariant.checking_flag=true;
	
	TransactionTest transactionTest = new TransactionTest();
	testClass(transactionTest);

	CreditAccountTest creditAccountTest = new CreditAccountTest();
	testClass(creditAccountTest);

	CurrencyTradingAccountTest currencyAccountTest = new CurrencyTradingAccountTest();
	testClass(currencyAccountTest);
	
	BankAccountTest bankAccountTest = new BankAccountTest();
	testClass(bankAccountTest);
	
	CustomerTest custTest = new CustomerTest();
	testClass(custTest);
	
	CheckTest checkTest = new CheckTest();
	testClass(checkTest);
	
	CheckbookTest checkbookTest = new CheckbookTest();
	testClass(checkbookTest);
    }
    static public void testClass(TestSuite o){
	o.printTestSuiteName();
	int count_testcases = 0;
	int count_failed    = 0;
	Class c = o.getClass();
	Boolean tmp_result;
	boolean result=false;
	String message="";
	Method[] theMethods = c.getMethods();
	for (int i = 0; i < theMethods.length; i++) {
	    if(theMethods[i].getName().startsWith("test")){
		count_testcases++;
		try {
		    tmp_result = (Boolean) theMethods[i].invoke(o,null);
		    if(tmp_result!=null) {
			result=tmp_result.booleanValue();
		    } else {
			result = false;
		    }
		} catch (InvocationTargetException e) {
		    //	    System.out.println(e.getTargetException().getClass());
		    // if (e.getTargetException() instanceof OCLException) {
		    if (  (e.getTargetException().getMessage()!=null)
                        &&(e.getTargetException().getMessage().indexOf("OCLException")) > 0) {
			int pos = e.getTargetException().getMessage().indexOf("violated");
			message = e.getTargetException().getMessage().substring(pos);
			result = false;
		    } else {		
			System.out.println(e.getTargetException());
			e.getTargetException().printStackTrace(System.out);
		    }
		} catch (IllegalAccessException e) {
                    System.out.println(e);
                } 
		if(result == false) {
		    count_failed++;
		    System.out.println("            failed: "+message);
		}
	    }
	}
	o.printTestSuiteSummary(count_testcases,count_failed);
    }
}
