(*****************************************************************************
 *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
 *                                                                            
 * OCL_Bag_type.thy - Type Defintion for Bag
 * Copyright (C) 2001,2002,2003,2004 Achim D. Brucker <brucker@inf.ethz.ch>   
 *                                   Burkhart Wolff   <bwolff@inf.ethz.ch>    
 *                                                                            
 * This file is part of HOL-OCL.                                              
 *                                                                            
 * HOL-OCL is free software; you can redistribute it and/or modify it under   
 * the terms of the GNU General Public License as published by the Free       
 * Software Foundation; either version 2 of the License, or (at your option)  
 * any later version.                                                         
 *                                                                            
 * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.                                                              
 *                                                                            
 * You should have received a copy of the GNU General Public License along    
 * with this program; if not, write to the Free Software Foundation, Inc.,    
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
 ******************************************************************************)

header {* Type Definition for Bag *}

theory OCL_Bag_type 
imports  
  "$HOLOCL_HOME/src/library/collection/OCL_Collection_type" 
  Multiset 
begin
 text_raw{* \label{thy:OCL_Bag_type} *}
typedef  'a Bag_0 = "{X::('a::bot) multiset up. True}"
apply (rule_tac x=\<bottom> in exI)
by (simp add: smash_def)


instance Bag_0 :: (type) ord
  by intro_classes

arities  Bag_0 :: (type) bot   (* declares \<bottom> *)
arities  Bag_0 :: (type) collection   (* declares Bag as a Collection *)

defs     UU_Bag_def: "\<bottom> \<equiv> Abs_Bag_0 down"

types    ('st,'b) Bag  = "('st, 'b Bag_0) VAL"

end 
